/* CoolTran, traductor de trminos.
 * 
 * Copyright (C) 2007
 *
 * Authors: Javier Garca Palacios <jgarcia1709@gmail.com>
 *          Diego Sevillano de Miguel <sevas85@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 */

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;


public class Busqueda {

	String cadPalabra = ""; 
	String capTipoDic = "";
	String cadDicWikiSeleccionado = "";
    int intNumeroPalabras = 0;
    ArrayList<String> arrayNumTermino = null;
    boolean booHayTraduccion1=false;
    boolean booHayTraduccion2=false;
    Termino cadTerm = null;
	
	
	public  Busqueda() {
		
	}
	
	public  Termino traducirLocal(String termino){
		
		
		capTipoDic="Local";
		cadPalabra = termino.toLowerCase();
		
			
		//Traducimos		

		//Creamos el Termino
		cadTerm = new Termino(cadPalabra, Configuracion.diccionarioLocalTraduc.getProperty(cadPalabra) ,capTipoDic);

		if(Configuracion.diccionarioLocalTraduc.getProperty(cadPalabra)==null){
			 //cambiar por mensaje en idiomas
			cadTerm.setTraduccion((Configuracion.messages.getString("noencontrado_local1")+"\n\n"+Configuracion.messages.getString("noencontrado_local2")));
		}
		
		return cadTerm;
	}
	
	public Termino traducirColaborativo(String termino,String dicColabSeleccionado,Conexion conexion){
		
		capTipoDic="Colaborativo";
		cadDicWikiSeleccionado = dicColabSeleccionado;
		cadPalabra = termino.toUpperCase();
		
		Connection con = null;
		String traduccion="";

		String query="";
		Statement stmt = null;
		ResultSet res = null;
		String fecha="";

		
		int longitud = cadPalabra.length() + 2 ;

	    PrintStream ps = null;
			
		
		    try {
		    	//Obtenemos la fecha actual
		    	SimpleDateFormat formato1 = new SimpleDateFormat("yyyyMMddHHmmss");
		    	fecha = formato1.format(System.currentTimeMillis());
		    	
				//Creamos el Termino
		    	cadTerm = new Termino(cadPalabra, "traduc"+fecha+".html" ,capTipoDic);
				
		    	  	
		    	File file =  new File(cadTerm.getTraduccion());
		    	 ps = new PrintStream(file);
		    	 ps.println("<html><body><table border=\"0\"  width=\"260\"><tr><td width=\"260\">");
		    	 
		    	 //Primero mostramos el resultado literal
		    	 
		    	query= "select d.traduccion, d.term , t.descripcion ,d.numtermino " +
		    		   " from  termino d  , clasepalabra t, diccionarios c "+
		    		   " where upper(d.term) like '"+cadPalabra+"' " +
		    		   " and (t.tipo = d.tipo)    " +
		    		   " and c.nombre = d.nombre "+
		    		   " and d.nombre like '"+cadDicWikiSeleccionado+"' "+
		    		   " and NOT EXISTS ( select * from   `valoracion` v where v.numtermino = d.numtermino and " +
		    		   " valido = 1) " ;

					
					con = conexion.con;
					try {
						stmt = con.createStatement();
						res = (ResultSet) stmt.executeQuery(query);
						intNumeroPalabras = 1;
						arrayNumTermino = new ArrayList<String>();
						
						while (res.next()){
							booHayTraduccion1=true;
							
							ps.println("<b><font size=\"4\" color=\"BLUE\">");
							traduccion = res.getString(2);
							ps.println(intNumeroPalabras+". "+traduccion);
							ps.println(" :");
							ps.println("</font></b>");
							
							ps.println("<font size=\"3\" color=\"RED\">");
							ps.println(res.getString(3));
							ps.println("</font>");
		
							ps.println("<font size=\"4\" color=\"BLACK\">");
							traduccion = res.getString(1);			
							ps.println(traduccion);
							ps.println("</font>");
							ps.println("<br>");
							//System.out.println("Terminos:"+ res.getString(4));
							arrayNumTermino.add(res.getString(4));
							intNumeroPalabras++;						
						}				

						
				    	 //Las posibles coincidencias
					    	 
						query= "select d.traduccion, SUBSTR(d.term,"+longitud+"),  t.descripcion " +
							   " from termino d  , clasepalabra t, diccionarios c "+
							   " where upper(d.term) like '"+cadPalabra+" %' "+
						 	   " and t.tipo = d.tipo   " +
				    		   " and c.nombre = d.nombre "+
				    		   " and d.nombre like '"+cadDicWikiSeleccionado+"' "+
							   " and NOT EXISTS ( select * from   `valoracion` v where v.numtermino = d.numtermino  and " +
						 	   " valido = 1) " ;
					
						
						//System.out.println("La query es "+query);
						
						con = conexion.con;
						 
						stmt = con.createStatement(); 
						res = (ResultSet) stmt.executeQuery(query);
						
						
						
						
						while (res.next()){
							booHayTraduccion2=true;
							
							ps.println("<b><font size=\"4\" color=\"#800000\">");
							traduccion = res.getString(2);
							ps.println("~ ");
							ps.println(traduccion);
							ps.println(" :");
							ps.println("</font></b>");
							
							ps.println("<font size=\"3\" color=\"RED\">");
							ps.println(res.getString(3));
							ps.println("</font>");
							
							ps.println("<font size=\"4\" color=\"BLACK\">");
							traduccion = res.getString(1);			
							ps.println(traduccion);
							ps.println("</font><br>");
							//traduccion = traduccion + res.getString(2)  + "\n\t "+ res.getString(1);
					
						
						}
						
						 //cambiar por mensaje en idiomas
						
						if (!booHayTraduccion1 && !booHayTraduccion2){ //si no ha encontrado el termino en la base de datos
							ps.println("<b><font size=\"4\" color=\"BLACK\">");
							ps.println(Configuracion.messages.getString("noencontrado_colaborativo1"));
							ps.println("<br><b>");
							ps.println("<br><b>");
							ps.println(Configuracion.messages.getString("noencontrado_colaborativo2"));
							ps.println("</font><br>");
						}
						
						ps.println("</td></tr></table></body></html>");
						
						//Cerramos punteros
						 stmt.close();
						 ps.close();
						 res.close();
							
					}catch (SQLException e) {						
						 System.out.println("Error Consulta SQL ");					
					}finally{						
					}
					 
		    } catch (IOException e) {      
		    	System.out.println("Error Creando La Traduccion");
			} 
			

		return cadTerm;
	}
	
	public int getNumeroPalabras(){
		return intNumeroPalabras-1;
	}
	
	public String getNumTermino(int valor){
		return arrayNumTermino.get(valor);
	}

}