/*
 * Copyright (C) 2004 Sun Microsystems, Inc. All rights reserved. Use is
 * subject to license terms.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Lesser GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA.
 */

import java.awt.event.*;
import java.util.ArrayList;
import javax.swing.*;
import org.jdesktop.jdic.tray.*;

public class IconoTray implements ActionListener, ItemListener {

    SystemTray tray = SystemTray.getDefaultSystemTray();
    public TrayIcon ti;
    public JPopupMenu menu;
    public JMenu  submenuLocal;
    public JMenu  submenuColaborativo;
    public JMenuItem menuItem;
    public JRadioButtonMenuItem rbMenuItemLocal;
    public JRadioButtonMenuItem rbMenuItemColaborativo;
    
    Aplicacion app;
    
    String tipoDic=null;
    String[] nombreDiccionarioLocal;
    ArrayList<String> nombreDiccionarioColaborativo;
    int numeroDiccionariosLocales=0;
    int numeroDiccionariosColaborativos=0;
    String DicLocalSeleccionado=null;
    int DicColaborativoSeleccionado=0;
    
    public void setTipoDicTray(String tipo){
    	tipoDic=tipo;
    }
    
    public void setDiccLocalesTray(int numeroDicLocales,String[] nombres,String seleccionado){
    	numeroDiccionariosLocales=numeroDicLocales;
    	nombreDiccionarioLocal=nombres;
    	DicLocalSeleccionado=seleccionado;
    }
    public void setDiccColaborativosTray(int numeroDicColaborativos,ArrayList<String> objects,int seleccionado){
    	numeroDiccionariosColaborativos=numeroDicColaborativos;
    	nombreDiccionarioColaborativo=objects;
    	DicColaborativoSeleccionado=seleccionado;
    }
    
    public void setConfiguracionTray(){
        
        //RadioButtons con Diccionario por defecto Local o Colaborativo
        ButtonGroup group = new ButtonGroup();

        rbMenuItemLocal = new JRadioButtonMenuItem(Configuracion.messages.getString("combo_local"));
        if (tipoDic.equals("Local")){
        	rbMenuItemLocal.setSelected(true);
        }
        group.add(rbMenuItemLocal);
        //rbMenuItemLocal.addActionListener(this);
        rbMenuItemLocal.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				app.controlador.panelInicial.panelPestanas.pestana1.desplegableTipoDic.setSelectedItem(Configuracion.messages.getString("combo_local"));
				app.config.cambiaTipoDic("Local");

				app.controlador.panelInicial.panelPestanas.pestana1.etiquetaValorar.setVisible(false);
				app.controlador.panelInicial.panelPestanas.pestana1.desplegableValorarValor.setVisible(false);
				app.controlador.panelInicial.panelPestanas.pestana1.desplegableValorarNum.setVisible(false);
				app.controlador.panelInicial.panelPestanas.pestana1.etiquetaValorar2.setVisible(false);
			}	
	    });
        menu.add(rbMenuItemLocal);

        rbMenuItemColaborativo = new JRadioButtonMenuItem(Configuracion.messages.getString("combo_colaborativo"));
        if (tipoDic.equals("Colaborativo")){
        	rbMenuItemColaborativo.setSelected(true);
        }
        group.add(rbMenuItemColaborativo);
        //rbMenuItemColaborativo.addActionListener(this);
        rbMenuItemColaborativo.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				app.controlador.panelInicial.panelPestanas.pestana1.desplegableTipoDic.setSelectedItem(Configuracion.messages.getString("combo_colaborativo"));
				app.config.cambiaTipoDic("Colaborativo");

				app.controlador.panelInicial.panelPestanas.pestana1.etiquetaValorar.setVisible(true);
				app.controlador.panelInicial.panelPestanas.pestana1.desplegableValorarValor.setVisible(true);
				app.controlador.panelInicial.panelPestanas.pestana1.desplegableValorarNum.setVisible(true);
				app.controlador.panelInicial.panelPestanas.pestana1.etiquetaValorar2.setVisible(true);
			}	
	    });
        menu.add(rbMenuItemColaborativo);
        
        //Submenu diccionarios Locales
        menu.addSeparator();
        submenuLocal = new JMenu(Configuracion.messages.getString("tray_locales"));

        ButtonGroup group2 = new ButtonGroup();

        for (int i=0;i<numeroDiccionariosLocales-1;i++){
	        menuItem = new JRadioButtonMenuItem(nombreDiccionarioLocal[i].substring(13,20));
	        if (DicLocalSeleccionado.equals(nombreDiccionarioLocal[i].substring(13,20))){
	        	menuItem.setSelected(true);
	        }
	        group2.add(menuItem);
	        //menuItem.addActionListener(this);
	        menuItem.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
					JMenuItem source = (JMenuItem) (e.getSource());
					app.config.cambiarDiccionario(String.valueOf(source.getText()));
					//cambia item seleccionado en aplicacion
					app.controlador.panelInicial.panelPestanas.pestana2.desplegableDicLocal.setSelectedItem(Configuracion.propiedades.getProperty("dicLocDefault"));
				}	
		    });
	        submenuLocal.add(menuItem);
        }
        menu.add(submenuLocal);
        
        //Submenu diccionarios Colaborativos
        menu.addSeparator();
        submenuColaborativo = new JMenu(Configuracion.messages.getString("tray_colaborativos"));

        ButtonGroup group3 = new ButtonGroup();
  
     
        
        for (int j=0;j<numeroDiccionariosColaborativos;j++){
	        menuItem = new JRadioButtonMenuItem( nombreDiccionarioColaborativo.get(j));
	        if (DicColaborativoSeleccionado==j){
	        	menuItem.setSelected(true);
	        }
	        group3.add(menuItem);
	        //menuItem.addActionListener(this);
	        menuItem.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
					JMenuItem source = (JMenuItem) (e.getSource());
					app.config.cambiaDicColab(String.valueOf(source.getText()));
					//cambia item seleccionado en aplicacion
					app.controlador.panelInicial.panelPestanas.pestana2.desplegableDicWiki.setSelectedItem(Configuracion.propiedades.getProperty("dicColDefault"));
				}	
		    });
	        submenuColaborativo.add(menuItem);
        }
        menu.add(submenuColaborativo);
        
        // "Quit" menu item
        menu.addSeparator();
        menuItem = new JMenuItem(Configuracion.messages.getString("tray_cerrar"));
        menuItem.addActionListener(this);
        menu.add(menuItem);   
    }

    
    
    public IconoTray(Aplicacion aplicacion) {
    	
    	app=aplicacion;
        
    /*  try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            e.printStackTrace();
        }
    */
    	
        if( Integer.parseInt(System.getProperty("java.version").substring(2,3)) >=5 )
            System.setProperty("javax.swing.adjustPopupLocationToFit", "false");
        menu = new JPopupMenu("A Menu");

        
        ImageIcon i = new ImageIcon("imagenes/icono_tray.png");

        ti = new TrayIcon(i, "CoolTran", menu);

        ti.setIconAutoSize(true);
		// Eventos del tray
		ti.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					
					app.controlador.setVisible(!app.controlador.isVisible());
					if (!app.controlador.getClipboardHabilitado()){
					  app.controlador.setClipboardHabilitado(true);
					
					}
				}
			});
        ti.addBalloonActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
              JOptionPane.showMessageDialog(null, 
              "Balloon Message been clicked - TrayIcon", "Message",
              JOptionPane.INFORMATION_MESSAGE);
            }
        });
        
        tray.addTrayIcon(ti);

    }

    // Returns just the class name -- no package info.
    protected String getClassName(Object o) {
        String classString = o.getClass().getName();
        int dotIndex = classString.lastIndexOf(".");

        return classString.substring(dotIndex + 1);
    }

    public void actionPerformed(ActionEvent e) {
        JMenuItem source = (JMenuItem) (e.getSource());
        String s = source.getText();
        if (s.equalsIgnoreCase(Configuracion.messages.getString("tray_cerrar"))) {
          
            System.exit(0);
        } else {
            s = "Action event detected." + "\n" + "    Event source: "
                + source + " (an instance of " + getClassName(source) + ")";
            
           
        }
    }

    public void itemStateChanged(ItemEvent e) {
        JMenuItem source = (JMenuItem) (e.getSource());
        String s = "Item event detected." + "\n" + "    Event source: "
                + source.getText() + " (an instance of " + getClassName(source)
                + ")" + "\n" + "    New state: "
                + ((e.getStateChange() == ItemEvent.SELECTED)
                        ? "selected"
                        : "unselected");

        System.out.println(s);
    }

}
